#include "../include/aprecv-general.h"

/* Move this to the apsrlib? (MP) */
/* No...well...perhaps...have to think about it :) (MK) */


/* The BPF filter will be optimized by pcap, so we just can strncat the	*/
/* "orred" filters							*/
/*									*/
/* TODO: If no filters are defined the filter routines will fail. FIXME */
/*									*/
#ifdef HAVE_APSRLIB_MODULE_SUPPORT
struct apsr_modules *dl_list=NULL;

int load_module (char *module_name) {
	char *error;					/* Error buffer */
	char *filter;					/* Temp filter */
	struct apsr_modules *p;
	struct apsr_aprecv_module_info module_info;	/* Module info struct */
	static int mod_cnt;				/* Module counter */
	static char *bpf_filter;			/* BPF filter */
	int add=7;					/* dirty hack */

        if (!(p=xcalloc(1, sizeof(struct apsr_modules))) ) {
		apsr_stream_output((FILE *) stderr, "Error while allocating memory for new module.\n");
	}
	
	p->dl_handle = dlopen(module_name, RTLD_NOW);

	if(!p->dl_handle) {
	  apsr_stream_output((FILE *) stderr, "%s\n", dlerror());
	  exit(EXIT_FAILURE);
	}

	/* Export the functions */
	get_module_info = dlsym(p->dl_handle, "module_info");
	if((error = dlerror()) != NULL)  {
	  apsr_stream_output((FILE *) stderr, error);
	  exit(EXIT_FAILURE);
	}

	p->init = dlsym(p->dl_handle, "module_init");
	if((error = dlerror()) != NULL)  {
	  apsr_stream_output((FILE *) stderr, error);
	  exit(EXIT_FAILURE);
	}

	module_info = get_module_info();
	apsr_output("Module name       : %s\n", module_info.name);
	apsr_output("Module version    : %s\n", module_info.version);
	apsr_output("Module filter     : %s\n", module_info.bpf_filter);

	/* Module counter */
	mod_cnt++;

	if(mod_cnt==1) {
		bpf_filter=xmalloc(1);	/* Need to (x)realloc */
		add=4;
	}

	filter = xmalloc(strlen(module_info.bpf_filter)+add);
	memset(filter, '\0', strlen(module_info.bpf_filter)+add);

	if(mod_cnt==1)
		strncpy(filter, "(", 1);
	else
		strncpy(filter, " or (", 5);

	strncat(filter, module_info.bpf_filter, strlen(module_info.bpf_filter));
	strncat(filter, ")", 1);
	module_info.bpf_filter = xmalloc(strlen(filter)+1);
	bpf_filter=xrealloc(bpf_filter, strlen(bpf_filter)+strlen(filter)+1);
	strncpy(bpf_filter+strlen(bpf_filter), filter, strlen(filter)+1);

	if(verbose)
          apsr_output("Module description: %s\n", module_info.desc);		
	
	apsr_output("\n");
	
	p->info.name		= module_info.name;
	p->info.version 	= module_info.version;
	p->info.bpf_filter	= bpf_filter;
	p->info.desc		= module_info.desc;
	p->info.family		= module_info.family;
	p->info.proto1		= module_info.proto1;
	p->info.proto2		= module_info.proto2;
	p->info.id1		= module_info.id1;
	p->info.id2     	= module_info.id2;
	p->info.id3     	= module_info.id3;
	p->info.id4     	= module_info.id4;

	p->next 		= dl_list;
	dl_list			= p;

	return(RET_SUCCESS);
}

void load_modules_in_path (char *directory) {
	DIR *d;
        struct dirent *file;
        char filename[MAX_PATH_LENGTH];

        if (!(d=opendir(directory))) {
	  apsr_output("Error while directory opening %s.\n", directory);
	  return;
        }

        while((file=readdir(d))) {
          if (file->d_name[0] == '.') 
		  continue;
		
          if (snprintf(filename, sizeof(filename)-1, "%s/%s", directory, file->d_name) > 0) {
	  	  load_module(filename);
          } else
	 	  apsr_output("Error while module loading from directory %s.\n",     		  directory);
   	} 

        if(closedir(d) < 0) {
		#ifdef APRECV_DEBUG
                apsr_output("Error: closedir failed!\n");
                #endif
        }
}	

void find_module(unsigned char *buf, int family, unsigned short proto1, unsigned short proto2, unsigned short id1, unsigned short id2) {
	struct apsr_modules *l;

        for(l=dl_list; l; l=l->next) {
		if (
		    /* Family check */
		    (family == l->info.family) && 
		    /* Protocol check */
		    (proto1 == l->info.proto1 || proto2 == l->info.proto2) &&
		    /* ID (port/socket) check */
		    (id1 == l->info.id1 || id2 == l->info.id2 || 
		     id1 == l->info.id2 || id2 == l->info.id1 ||
		     id1 == l->info.id3 || id2 == l->info.id4 ||
		     id1 == l->info.id4 || id2 == l->info.id3)
		   ) {
			(*l->init)(buf, family, proto1, id1, id2);
			return;
                }
        }

}

void close_modules() {
	struct apsr_modules *l;

	for(l=dl_list; l; l=l->next) {
		#ifdef APRECV_DEBUG
		apsr_output("Debug: dlclose module %s.\n", l->info.name);
		#endif
		if(dlclose(l->dl_handle) != 0) {
	                #ifdef APRECV_DEBUG
        	        apsr_output("Error: dlclose for module %s failed!\n", l->info.name);
                	#endif
		}
 	}
}
#endif

