#include "../include/aprecv-general.h"

static const char *cbttypes[]= {
	" (Hello)",
	" (Join request)",
	" (Join ack)",
	" (Quit notification)",
	" (Echo request)",
	" (Echo reply)",
	" (Flush tree)",
	" (Bootstrap message)",
	" (Candidate Core Advertisement)",
};

int print_cbt_packet (struct aprecv_frame_header *header, unsigned char *packet, int opt_size) {
  static struct cbt_pkt_header *cbt_header;
  static unsigned short version, type;

  cbt_header = (struct cbt_pkt_header *)(packet+data_link_size+opt_size);
  
  version 	= APSR_CBT_VERSION(cbt_header);
  type		= APSR_CBT_TYPE(cbt_header);

  apsr_output("- CBT Header -\n  Version: %u, Type: %u",
		  version, type);
  
  if(verbose)
	  apsr_output("%s", cbttypes[type]);
  
  apsr_output("\n  Address Length: %u, Checksum: 0x%02x\n",
		  cbt_header->addr_length, apsr_ntohs(cbt_header->sum));
  
  if(statistic) 
          stats.c.cbt++;

  return(RET_SUCCESS);
}
