#include "../include/aprecv-general.h"

int print_cgmp_packet (unsigned char *packet, int opt_size) {
  static struct cgmp_pkt_header *cgmp_header;
    
  cgmp_header = (struct cgmp_pkt_header *)(packet+data_link_size+opt_size);

  apsr_output("- CGMP Header -\n  Version: %u, Type: %u\n", 
		  APSR_CGMP_VERSION(cgmp_header), 
		  APSR_CGMP_TYPE(cgmp_header));
  apsr_output("  Reserved: %u, Count: %u\n",
		  apsr_ntohs(cgmp_header->reserved),
		  cgmp_header->count);
  apsr_output("  GDA: %02c%02c.%02c%02c.%02c%02c, USA: %02c%02c.%02c%02c.%02c%02c\n", 
		  cgmp_header->gda[0], cgmp_header->gda[1],
		  cgmp_header->gda[2], cgmp_header->gda[3],
		  cgmp_header->gda[4], cgmp_header->gda[5],
		  cgmp_header->usa[0], cgmp_header->usa[1],
		  cgmp_header->usa[2], cgmp_header->usa[3],
		  cgmp_header->usa[4], cgmp_header->usa[5]);

  if(statistic) 
          stats.c.cgmp++;
  
  return(RET_SUCCESS);
}
