#include "../include/aprecv-general.h"

static const char *gsmp_results[]= {
	" (Unknown)",
	" (NoSuccessAck)",
	" (AckAll)",
	" (Success)",
	" (Failure)",
};

int print_gsmp_packet (unsigned char *packet, int opt_size) {
  static struct gsmp_pkt_header *gsmp_header;
  
  gsmp_header = (struct gsmp_pkt_header *)(packet+data_link_size+opt_size);
  
  apsr_output("- GSMP Header -\n  Version: %u, ", gsmp_header->version);
  apsr_output("Type: %u\n Result: %u", gsmp_header->type, gsmp_header->result);
  if(verbose) 
	  apsr_output("%s", gsmp_results[gsmp_header->result]);
  apsr_output("\n  Code: %u\n", gsmp_header->code);
	
  if(statistic)
	stats.c.gsmp++;
  
  return(RET_SUCCESS);
}
