/* Include some header files */
#include "apsrstack-structs.h"
#include "apsrstack-ipv4.h"
#include "apsrstack-udp.h"
#include "apsrstack-tcp.h"
#include "apsrstack-globals.h"

/* Prototypes */
typedef void (*apsrstack_queue_check_callback)(int);

/* apsrstack.c / TODO: later scheduler.c */
void queue_check		(int);

/* api.c */
void apsrstack_listen_add	(unsigned char, unsigned short);	
void apsrstack_listen_remove    (unsigned char, unsigned short);

/* parseoptions.c */
int parseoptions                (int, char **);          

/* usage.c */
int usage                       (char *, char *);         
int showversion 		(void);			 

/* error.c */
void clean_exit			(int);                    

/* statistic.c */	
void statistic			(void);
void cap_stats			(void);			  

/* receive_apsrlib.c */
int start_sniffing_apsr         (int, int, int);
int recv_packet_apsr 		(struct sockaddr *, unsigned char *, unsigned int);

/* ethernet.c */
void process_ethernet_packet	(struct apsrstack_frame_header *, void *, int);
void switchto_ethernet_proto    (struct apsrstack_frame_header *, void *, int, 
		                 unsigned short);

/* ipv4.c */
void process_ipv4_packet	(struct apsrstack_frame_header *, void *, int); 
void switchto_ipv4_proto	(struct apsrstack_frame_header *, void *, int, 
		                 unsigned short);

/* arp.c */
void process_arp_packet		(void *, int);
void send_arp			(unsigned char *, unsigned char *,
		                 unsigned short, unsigned short,
				 unsigned short, unsigned char,
				 unsigned char, unsigned short,
				 unsigned char *, unsigned char *,
				 unsigned char *, unsigned char *);
	
/* icmpv4.c */ 	
void process_icmpv4_packet	(struct apsrstack_frame_header *, void *, int);
void send_icmpv4_timestamp      (struct apsrstack_frame_header *,unsigned char,
                                 unsigned char, unsigned short,
                                 struct in_addr, struct in_addr,
                                 unsigned char, unsigned char,
                                 unsigned char, unsigned short,
                                 unsigned short, unsigned int, unsigned int,
				 unsigned int);
void send_icmpv4_echo           (struct apsrstack_frame_header *,unsigned char,
		                 unsigned char, unsigned short,
		                 struct in_addr, struct in_addr,
		                 unsigned char, unsigned char,
		                 unsigned char, unsigned short,
		                 unsigned short, unsigned char *,
				 unsigned short);
void send_icmpv4	        (struct apsrstack_frame_header *,unsigned char,
                                 unsigned char, unsigned short,
                                 struct in_addr, struct in_addr,
                                 unsigned char, unsigned char,
                                 unsigned char, unsigned char *,
				 unsigned short);

/* tcp.c */
void process_tcp_packet		(struct apsrstack_frame_header *, void *, int);
void send_tcp			(struct apsrstack_frame_header *,unsigned char,
			         unsigned char, unsigned short,
	                         struct in_addr, struct in_addr,
		                 unsigned char, unsigned short,
		                 unsigned short, unsigned int,
		                 unsigned int, unsigned char, unsigned char,
		                 unsigned char, unsigned char,
                                 unsigned short, unsigned short,
                                 unsigned char *, unsigned short);

/* udp.c */
void process_udp_packet         (struct apsrstack_frame_header *, void *, int);

/* time.c */
void service_time_init		();
void service_time_close		();
int service_time_main		();



