/* Connection state / rfc 793 */
#define APSRSTACK_TCP_STATE_LISTEN		1
#define APSRSTACK_TCP_STATE_SYN_SENT		2
#define APSRSTACK_TCP_STATE_SYN_RECEIVED	3
#define APSRSTACK_TCP_STATE_ESTABLISHED		4
#define APSRSTACK_TCP_STATE_FIN_WAIT_1		5
#define APSRSTACK_TCP_STATE_FIN_WAIT_2		6
#define APSRSTACK_TCP_STATE_CLOSE_WAIT		7
#define APSRSTACK_TCP_STATE_CLOSING		8
#define APSRSTACK_TCP_STATE_LAST_ACK		9
#define APSRSTACK_TCP_STATE_TIME_WAIT		10
#define APSRSTACK_TCP_STATE_CLOSED		11

/* For now(don't panic ;-)) it will be for any state 600 seconds */
#define APSRSTACK_TCP_STATES_TIMEOUT		600	

#define APSRSTACK_TCP_DEFAULT_WINDOW_SIZE	1460	/* Ethernet */
#define APSRSTACK_TCP_DEFAULT_MSS		1460	/* Ethernet */

struct tcp_option_mss {
  unsigned int option:8;
  unsigned int length:8;
  unsigned short mss;
};

struct tcp_connection {
  unsigned char state;		/* Connection state */
  unsigned char last_flag;	/* Last flag from peer */
  struct in_addr peer_ip;	/* IPv4 address of peer */
  unsigned short local_port;	/* Local port */
  unsigned short peer_port;	/* Port of peer */
  unsigned int seq_next;	/* Next sequence number */
  unsigned int ack_next;	/* Next ack sequence number */
  unsigned short timeout;	/* Timeout */
};

#define APSRSTACK_TCP_MAX_PORTS			65535
#define APSRSTACK_TCP_MAX_CONNECTIONS           255

struct tcp_connection tcp_queue[APSRSTACK_TCP_MAX_CONNECTIONS];

unsigned short tcp_listen_ports[APSRSTACK_TCP_MAX_PORTS];

