#include "../include/apsrstack-general.h"

/* Add port to listen queue */
void apsrstack_listen_add(unsigned char protocol, unsigned short port) {
  unsigned short c = 0;
  
  if(protocol == APSR_PROTO_TCP) {
    for(c = 0; c < APSRSTACK_TCP_MAX_PORTS; c++) {
      if(tcp_listen_ports[c] == 0) {
        tcp_listen_ports[c] = apsr_htons(port);
        break;
      }
    }
  }
  else if(protocol == APSR_PROTO_UDP) {
    for(c = 0; c < APSRSTACK_UDP_MAX_PORTS; c++) {
      if(udp_listen_ports[c] == 0) {
        udp_listen_ports[c] = apsr_htons(port);
        break;
      }
    }
  }
  else if(protocol == APSR_PROTO_SCTP) {
    /* TODO */
  } 
}  

/* Remove port from listen queue */
void apsrstack_listen_remove(unsigned char protocol, unsigned short port) {
  unsigned short c = 0;
  unsigned short search_port = apsr_htons(port);
 
  if(protocol == APSR_PROTO_TCP) {
    for(c = 0; c < APSRSTACK_TCP_MAX_PORTS; c++) {
      if(tcp_listen_ports[c] == search_port) {
        tcp_listen_ports[c] = 0;
        break;
      }
    }
  }
  else if(protocol == APSR_PROTO_UDP) {
    for(c = 0; c < APSRSTACK_UDP_MAX_PORTS; c++) {
      if(udp_listen_ports[c] == search_port) {
        udp_listen_ports[c] = 0;
        break;
      }
    }
  }
  else if(protocol == APSR_PROTO_SCTP) {
    /* TODO */
  }
}

