/* APSR Data Link Types (DLTs) */
/* Most are from libpcaps bpf.h as this is the first place to look for DLTs */

#define APSR_DLT_NULL		0	/* no link-layer encapsulation */
#define APSR_DLT_EN10MB		1	/* Ethernet (10Mb) */
#define APSR_DLT_EN3MB		2	/* Experimental Ethernet (3Mb) */
#define APSR_DLT_AX25		3	/* Amateur Radio AX.25 */
#define APSR_DLT_PRONET		4	/* Proteon ProNET Token Ring */
#define APSR_DLT_CHAOS		5	/* Chaos */
#define APSR_DLT_IEEE802	6	/* IEEE 802 Networks */
#define APSR_DLT_ARCNET		7	/* ARCNET */
#define APSR_DLT_SLIP		8	/* Serial Line IP (SLIP) */
#define APSR_DLT_PPP		9	/* Point-to-point Protocol (PPP) */
#define APSR_DLT_FDDI		10	/* FDDI */
#define APSR_DLT_ATM_RFC1483	11	/* LLC/SNAP encapsulated ATM */
#define APSR_DLT_RAW		12	/* Raw IP */
#define APSR_DLT_SLIP_BSDOS	15	/* BSD/OS Serial Line IP */
#define APSR_DLT_PPP_BSDOS	16	/* BSD/OS Point-to-point Protocol */
#define APSR_DLT_ATM_CLIP	19	/* Linux Classical-IP over ATM */
#define APSR_DLT_PPP_SERIAL	50	/* PPP over serial with HDLC encap. */
#define APSR_DLT_PPP_ETHER	51	/* PPP over Ethernet */
#define APSR_DLT_C_HDLC		104	/* Cisco HDLC */
#define APSR_DLT_CHDLC		104	/* Same as CISCO HDLC */
#define APSR_DLT_IEEE802_11	105	/* IEEE 802.11 wireless */
#define APSR_DLT_LOOP		108	/* OpenBSD Loopback */
#define APSR_DLT_LINUX_SLL	113	/* Linux cooked sockets */
#define APSR_DLT_LTALK		114	/* Apple LocalTalk hardware */
#define APSR_DLT_ECONET		115	/* Acorn Econet */
#define APSR_DLT_IPFILTER	116	/* OpenBSD IP filter */
#define APSR_DLT_PFLOG		117	/* Linuxs' OpenBSD PFLOG */
#define APSR_DLT_CISCO_IOS	118	/* Reserved for Cisco IOS internal */
#define APSR_DLT_PRISM_HEADER	119	/* 802.11 cards using Prism II chips */
#define APSR_DLT_AIRONET_HEADER	120	/* Aironet 802.11 cards */
#define APSR_DLT_SUNATM		123	/* SunATM(Solaris) */
