/* PIMv1 definitions */
#define APSR_PIMV1_TYPE_QUERY		0	/* Query		*/
#define APSR_PIMV1_TYPE_REGISTER	1	/* Register		*/
#define APSR_PIMV1_TYPE_REGISTER_STOP   2       /* Register-Stop	*/
#define APSR_PIMV1_TYPE_JOIN_PRUNE      3       /* Join/Prune		*/
#define APSR_PIMV1_TYPE_RP_REACH	4	/* RP-reachable		*/
#define APSR_PIMV1_TYPE_ASSERT          5       /* Assert		*/
#define APSR_PIMV1_TYPE_GRAFT           6       /* Graft(PIM-DM only)	*/
#define APSR_PIMV1_TYPE_GRAFT_ACK       7       /* Graft-Ack(PIM-DM)	*/
#define APSR_PIMV1_TYPE_MODE            8       /* Mode			*/

/* PIMv2 definitions */
#define APSR_PIMV2_TYPE_HELLO		0	/* Hello		*/
#define APSR_PIMV2_TYPE_REGISTER	1	/* Register		*/
#define APSR_PIMV2_TYPE_REGISTER_STOP	2	/* Register-Stop	*/
#define APSR_PIMV2_TYPE_JOIN_PRUNE	3	/* Join/Prune		*/
#define APSR_PIMV2_TYPE_BOOTSTRAP	4	/* Bootstrap		*/
#define APSR_PIMV2_TYPE_ASSERT		5	/* Assert		*/
#define APSR_PIMV2_TYPE_GRAFT		6	/* Graft(PIM-DM only)	*/
#define APSR_PIMV2_TYPE_GRAFT_ACK	7	/* Graft-Ack(PIM-DM only) */
#define APSR_PIMV2_TYPE_CAND		8	/* Candidate-RP-Advertisement */
#define APSR_PIMV2_TYPE_PRUNE_REFRESH	9 	/* Prune-Refresh	*/

/* Option types */
#define APSR_PIMV2_TYPE_HELLO_HOLDTIME    1	/* Hold-time		*/

/* Macros */
#define APSR_PIM_VERSION(pim_ps_header)(((pim_ps_header)->ver_type & 0xf0) >> 4)
#define APSR_PIM_TYPE(pim_ps_header)   ((pim_ps_header)->ver_type & 0x0f)

