#include "../include/apsrlib-config.h"

/* Create a IGMPv2 packet. */
int apsr_igmpv2 (unsigned int type, unsigned int max_res_time,
		 unsigned short sum, unsigned long group_addr,
		 const unsigned char *payload, int payload_size,
		 unsigned char *buf)
{
	static struct igmpv2_pkt_header igmpv2_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_igmpv2: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	igmpv2_hdr.type			= type;
	igmpv2_hdr.max_res_time		= max_res_time;
	igmpv2_hdr.sum			= sum;
	igmpv2_hdr.group_addr.s_addr	= group_addr;

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_IGMPv2, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&igmpv2_hdr,
	       APSR_IGMPv2);

	return(RET_SUCCESS);
}

