#include "../include/apsrlib.h"

int apsr_output (char *fmt, ...) {
	#ifndef HAVE_STDARG_H
	#error "apsr_output needs stdarg functions"
	#endif

	va_list ap;

	if(APSR_QUIET == 0 && APSR_RQUIET == 0) {
		va_start (ap, fmt);
		vfprintf(stdout, fmt, ap);
		va_end(ap);
	}
	
	return(RET_SUCCESS);
}

int apsr_stream_output (FILE *stream, char *fmt, ...) {
	#ifndef HAVE_STDARG_H
	#error "apsr_error_output needs stdarg functions"
	#endif
	
	va_list ap;
	
	if((APSR_QUIET == 1 && stream == (FILE *) stderr) || APSR_QUIET == 0) {
		if(APSR_RQUIET == 0) {
			va_start (ap, fmt);
			vfprintf((FILE *) stream, fmt, ap);
			va_end(ap);
		}
	}

	return(RET_SUCCESS);
}


/* Toggle quiet mode */
int apsr_toggle_quiet (void) {
	if(APSR_QUIET == 0)
		APSR_QUIET=1;
	else
		APSR_QUIET=0;

	return(APSR_QUIET);
}

/* Set quiet mode */
void apsr_set_quiet (void) {
	APSR_QUIET=1;
}

/* Unset quiet modee */
void apsr_unset_quiet (void) {
	APSR_QUIET=0;
}


/* Toggle "real" quiet mode */
int apsr_toggle_rquiet (void) {
	if(APSR_RQUIET == 0)
		APSR_RQUIET=1;
	else
		APSR_RQUIET=0;
	
	return(APSR_RQUIET);
}

/* Set "real" quiet mode */
void apsr_set_rquiet (void) {
	APSR_RQUIET=1;
}

/* Unset "real" quiet mode */
void apsr_unset_rquiet (void) {
	APSR_RQUIET=0;
}
