#include "../include/apsrserver-general.h"

int parseoptions (int argc, char *argv[]) {
  static struct gengetopt_args_info args_info;
  unsigned short port;

  if(cmd_parser (argc, argv, &args_info) != 0) {
    apsr_stream_output((FILE *) stderr, "Error: Unable to parse the command line!\n");
    exit(EXIT_FAILURE);
  }

  if(args_info.help_given) usage(argv[0], "");
  if(args_info.version_given) showversion();

  if(args_info.port_given) {
    port=args_info.port_arg;
  } else {
    port=APSRSERVER_PORT;
  }

  start_server(port);

  return(RET_SUCCESS);
}
