#include <apsrlib/apsrlib.h>

#define MODULE_VERSION		"0.01"
#define MODULE_NAME		"example"
#define MODULE_DESCRIPTION	"Example module for apsr project."
#define MODULE_IDENT_FAMILY	AF_INET
#define MODULE_IDENT_PN1	APSR_PROTO_TCP
#define MODULE_IDENT_PN2	APSR_PROTO_UDP
#define MODULE_IDENT_ID1	1234	
#define MODULE_IDENT_ID2	1234
#define MODULE_IDENT_ID3        1234
#define MODULE_IDENT_ID4        1234

#define MODULE_FILTER		"(tcp or udp) and port 123456789"

struct mod_example_header {
	unsigned char test1;
	unsigned short test2;
};

struct apsr_aprecv_module_info module_info (void) {
	struct apsr_aprecv_module_info module_info;

	module_info.version	= MODULE_VERSION;
	module_info.name	= MODULE_NAME;
	module_info.desc	= MODULE_DESCRIPTION;
	module_info.bpf_filter	= MODULE_FILTER; 
  	module_info.family      = MODULE_IDENT_FAMILY;
    	module_info.proto1      = MODULE_IDENT_PN1;
      	module_info.proto2      = MODULE_IDENT_PN2;
        module_info.id1         = MODULE_IDENT_ID1;
	module_info.id2         = MODULE_IDENT_ID2;
	module_info.id3         = MODULE_IDENT_ID3;
	module_info.id4         = MODULE_IDENT_ID4;
	      
	return(module_info);
}

extern char verbose;

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned short id1, unsigned short id2)
{
  struct mod_example_header *example_header;
	
  if(MODULE_IDENT_FAMILY == family && (MODULE_IDENT_PN1 == protocol_number || MODULE_IDENT_PN2 == protocol_number) && (MODULE_IDENT_ID1 == id1 || MODULE_IDENT_ID2 == id2)) {
	    example_header = (struct mod_example_header *)buf;
	    apsr_output("- Example Module Header -\n");
	    apsr_output("  Test1: %u\n", example_header->test1);
	    if(verbose)
		    apsr_output("  Test2: %u", 
				    apsr_ntohs(example_header->test2)); 
  }	    

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\n1: %i\n2: %i\n",
     family, protocol_number, id1, id2);
  #endif
  
  return(RET_SUCCESS);
}
