#include <apsrlib/apsrlib.h>

#define MODULE_VERSION		"0.01"
#define MODULE_NAME		"iSNS"
#define MODULE_DESCRIPTION	"Example Internet Storage Name Service protocol sniffer."
#define MODULE_IDENT_FAMILY	AF_INET
#define MODULE_IDENT_PN1	APSR_PROTO_TCP
#define MODULE_IDENT_PN2	APSR_PROTO_UDP
#define MODULE_IDENT_ID1	3205	
#define MODULE_IDENT_ID2	3205

#define MODULE_FILTER		"(tcp or udp) and port 3205"

struct mod_isns_header {
	unsigned short version;
	unsigned short function_id;
	unsigned short length;
	unsigned short flags;
	unsigned short transaction_id;
	unsigned short sequence_id;
};

struct apsr_aprecv_module_info module_info (void) {
	struct apsr_aprecv_module_info module_info;

	module_info.version	= MODULE_VERSION;
	module_info.name	= MODULE_NAME;
	module_info.desc	= MODULE_DESCRIPTION;
	module_info.bpf_filter	= MODULE_FILTER; 
        module_info.family      = MODULE_IDENT_FAMILY;
        module_info.proto1      = MODULE_IDENT_PN1;
        module_info.proto2      = MODULE_IDENT_PN2;
        module_info.id1         = MODULE_IDENT_ID1;
        module_info.id2         = MODULE_IDENT_ID2;
        module_info.id3         = 0;
        module_info.id4         = 0;
							
	return(module_info);
}

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned short id1, unsigned short id2)
{
  struct mod_isns_header *isns_header;
	
  if(MODULE_IDENT_FAMILY == family && (MODULE_IDENT_ID1 == id1 || MODULE_IDENT_ID2 == id2)) {
	    isns_header = (struct mod_isns_header *)buf;
	    apsr_output("- iSNS Header -\n");
	    apsr_output("  Version: %u, Function ID: %u\n", 
			    apsr_ntohs(isns_header->version),
			    apsr_ntohs(isns_header->function_id));
	    apsr_output("  Length: %u, Flags: 0x%02x\n",
			    apsr_ntohs(isns_header->length),
			    apsr_ntohs(isns_header->flags));
	    apsr_output("  Transaction ID: %u, Sequence ID: %u\n",
			    apsr_ntohs(isns_header->transaction_id),
			    apsr_ntohs(isns_header->sequence_id));
  }

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\n1: %i\n2: %i\n",
     family, protocol_number, id1, id2);
  #endif
  
  return(RET_SUCCESS);
}
